## bootc 1.9.0+composefs+vendor

=== Makefile ===
prefix ?= /usr

SOURCE_DATE_EPOCH ?= $(shell git log -1 --pretty=%ct)
# https://reproducible-builds.org/docs/archives/
TAR_REPRODUCIBLE = tar --mtime="@${SOURCE_DATE_EPOCH}" --sort=name --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime

# Enable rhsm if we detect the build environment is RHEL-like.
# We may in the future also want to include Fedora+derivatives as
# the code is really tiny.
# (Note we should also make installation of the units conditional on the rhsm feature)
CARGO_FEATURES ?= $(shell . /usr/lib/os-release; if echo "$$ID_LIKE" |grep -qF rhel; then echo rhsm; fi)

all: bin manpages

bin:
	cargo build --release --features "$(CARGO_FEATURES)"

# Generate man pages from markdown sources
MAN5_SOURCES := $(wildcard docs/src/man/*.5.md)
MAN8_SOURCES := $(wildcard docs/src/man/*.8.md)
TARGETMAN := target/man
MAN5_TARGETS := $(patsubst docs/src/man/%.5.md,$(TARGETMAN)/%.5,$(MAN5_SOURCES))
MAN8_TARGETS := $(patsubst docs/src/man/%.8.md,$(TARGETMAN)/%.8,$(MAN8_SOURCES))

$(TARGETMAN)/%.5: docs/src/man/%.5.md
	@mkdir -p $(TARGETMAN)
	go-md2man -in $< -out $@

$(TARGETMAN)/%.8: docs/src/man/%.8.md
	@mkdir -p $(TARGETMAN)
	go-md2man -in $< -out $@

manpages: $(MAN5_TARGETS) $(MAN8_TARGETS)

STORAGE_RELATIVE_PATH ?= $(shell realpath -m -s --relative-to="$(prefix)/lib/bootc/storage" /sysroot/ostree/bootc/storage)
install:
	install -D -m 0755 -t $(DESTDIR)$(prefix)/bin target/release/bootc
	install -D -m 0755 -t $(DESTDIR)$(prefix)/bin target/release/system-reinstall-bootc
	install -d -m 0755 $(DESTDIR)$(prefix)/lib/bootc/bound-images.d
	install -d -m 0755 $(DESTDIR)$(prefix)/lib/bootc/kargs.d
	ln -s "$(STORAGE_RELATIVE_PATH)" "$(DESTDIR)$(prefix)/lib/bootc/storage"
	install -D -m 0755 crates/cli/bootc-generator-stub $(DESTDIR)$(prefix)/lib/systemd/system-generators/bootc-systemd-generator 
	install -d $(DESTDIR)$(prefix)/lib/bootc/install
	if [ -n "$(MAN5_TARGETS)" ]; then \
	  install -D -m 0644 -t $(DESTDIR)$(prefix)/share/man/man5 $(MAN5_TARGETS); \
	fi
	if [ -n "$(MAN8_TARGETS)" ]; then \
	  install -D -m 0644 -t $(DESTDIR)$(prefix)/share/man/man8 $(MAN8_TARGETS); \
	fi
	install -D -m 0644 -t $(DESTDIR)/$(prefix)/lib/systemd/system systemd/*.service systemd/*.timer systemd/*.path systemd/*.target
	install -d -m 0755 $(DESTDIR)/$(prefix)/lib/systemd/system/multi-user.target.wants
	ln -s ../bootc-status-updated.path $(DESTDIR)/$(prefix)/lib/systemd/system/multi-user.target.wants/bootc-status-updated.path
	ln -s ../bootc-status-updated-onboot.target $(DESTDIR)/$(prefix)/lib/systemd/system/multi-user.target.wants/bootc-status-updated-onboot.target
	install -D -m 0644 -t $(DESTDIR)/$(prefix)/share/doc/bootc/baseimage/base/usr/lib/ostree/ baseimage/base/usr/lib/ostree/prepare-root.conf
	install -d -m 755 $(DESTDIR)/$(prefix)/share/doc/bootc/baseimage/base/sysroot
	cp -PfT baseimage/base/ostree $(DESTDIR)/$(prefix)/share/doc/bootc/baseimage/base/ostree 
	# Ensure we've cleaned out any possibly older files
	rm -vrf $(DESTDIR)$(prefix)/share/doc/bootc/baseimage/dracut
	rm -vrf $(DESTDIR)$(prefix)/share/doc/bootc/baseimage/systemd
	# Copy dracut and systemd config files
	cp -Prf baseimage/dracut $(DESTDIR)$(prefix)/share/doc/bootc/baseimage/dracut
	cp -Prf baseimage/systemd $(DESTDIR)$(prefix)/share/doc/bootc/baseimage/systemd
	# Install fedora-bootc-destructive-cleanup in fedora derivatives 
	ID=$$(. /usr/lib/os-release && echo $$ID); \
	ID_LIKE=$$(. /usr/lib/os-release && echo $$ID_LIKE); \
	if [ "$$ID" = "fedora" ] || [[ "$$ID_LIKE" == *"fedora"* ]]; then \
	ln -s ../bootc-destructive-cleanup.service $(DESTDIR)/$(prefix)/lib/systemd/system/multi-user.target.wants/bootc-destructive-cleanup.service; \
	install -D -m 0755 -t $(DESTDIR)/$(prefix)/lib/bootc contrib/scripts/fedora-bootc-destructive-cleanup; \
	fi

# Run this to also take over the functionality of `ostree container` for example.
# Only needed for OS/distros that have callers invoking `ostree container` and not bootc.
install-ostree-hooks:
	install -d $(DESTDIR)$(prefix)/libexec/libostree/ext
	for x in ostree-container ostree-ima-sign ostree-provisional-repair; do \
	  ln -sf ../../../bin/bootc $(DESTDIR)$(prefix)/libexec/libostree/ext/$$x; \
	done

# Install code in the initramfs, off by default except in builds from git main right now
# Also the systemd unit hardcodes /usr so we give up the farce of supporting $(prefix)
install-initramfs:
	install -D -m 0644 -t $(DESTDIR)/usr/lib/systemd/system crates/initramfs/*.service
	install -D -m 0755 target/release/bootc-initramfs-setup $(DESTDIR)/usr/lib/bootc/initramfs-setup

# Install initramfs files, including dracut module
install-initramfs-dracut: install-initramfs
	install -D -m 0755 -t $(DESTDIR)/usr/lib/dracut/modules.d/51bootc crates/initramfs/dracut/module-setup.sh

# Install the main binary, the ostree hooks, and the integration test suite.
install-all: install install-ostree-hooks
	install -D -m 0755 target/release/tests-integration $(DESTDIR)$(prefix)/bin/bootc-integration-tests

bin-archive: all
	$(MAKE) install DESTDIR=tmp-install && $(TAR_REPRODUCIBLE) --zstd -C tmp-install -cf target/bootc.tar.zst . && rm tmp-install -rf

test-bin-archive: all
	$(MAKE) install-all DESTDIR=tmp-install && $(TAR_REPRODUCIBLE) --zstd -C tmp-install -cf target/bootc.tar.zst . && rm tmp-install -rf

test-tmt:
	cargo xtask test-tmt

test:
	tests/build.sh && tests/test.sh

# This gates CI by default. Note that for clippy, we gate on
# only the clippy correctness and suspicious lints, plus a select
# set of default rustc warnings.
# We intentionally don't gate on this for local builds in cargo.toml
# because it impedes iteration speed.
CLIPPY_CONFIG = -A clippy::all -D clippy::correctness -D clippy::suspicious -D clippy::disallowed-methods -Dunused_imports -Ddead_code
validate-rust:
	cargo fmt -- --check -l
	cargo test --no-run
	(cd crates/ostree-ext && cargo check --no-default-features)
	(cd crates/lib && cargo check --no-default-features)
	cargo check --features=composefs-backend
	cargo clippy -- $(CLIPPY_CONFIG)
	env RUSTDOCFLAGS='-D warnings' cargo doc --lib
.PHONY: validate-rust
fix-rust:
	cargo clippy --fix --allow-dirty -- $(CLIPPY_CONFIG)
.PHONY: fix-rust

validate: validate-rust
	ruff check
.PHONY: validate

update-generated:
	cargo xtask update-generated
.PHONY: update-generated

vendor:
	cargo xtask $@
.PHONY: vendor

package-rpm:
	cargo xtask $@
.PHONY: package-rpm

=== vendor/ostree/rust-bindings/Makefile ===
GIR_REPO := https://github.com/gtk-rs/gir.git
GIR_VERSION := 19ccbbc9a3d1cc9271b7a5fa5d84b5652ee99492 # 0.21.0
GIR_FILES_VERSION := 0.20.0
OSTREE_REPO := ../ostree
OSTREE_VERSION := patch-v2022.2
RUSTDOC_STRIPPER_VERSION := 0.1.17

all: gir

.PHONY: gir gir-report update-gir-files remove-gir-files merge-lgpl-docs ci-build-stages


# -- gir generation --
target/tools/bin/gir:
	cargo install --root target/tools --git $(GIR_REPO) --rev $(GIR_VERSION) -- gir

gir: target/tools/bin/gir
	target/tools/bin/gir -c conf/ostree-sys.toml
	target/tools/bin/gir -c conf/ostree.toml

gir-report: target/tools/bin/gir
	target/tools/bin/gir -c conf/ostree.toml -m not_bound


# -- LGPL docs generation --
target/tools/bin/rustdoc-stripper:
	cargo install --root target/tools --version $(RUSTDOC_STRIPPER_VERSION) -- rustdoc-stripper

merge-lgpl-docs: target/tools/bin/gir target/tools/bin/rustdoc-stripper
	target/tools/bin/gir -c conf/ostree.toml -m doc
	target/tools/bin/rustdoc-stripper -g -o target/vendor.md


# -- gir file management --
update-gir-files: \
	remove-gir-files \
	gir-files \
	gir-files/GLib-2.0.gir \
	gir-files/GModule-2.0.gir \
	gir-files/Gio-2.0.gir \
	gir-files/GObject-2.0.gir \
	gir-files/OSTree-1.0.gir

remove-gir-files:
	rm -f gir-files/*.gir

gir-files:
	mkdir -p gir-files

%.gir:
	curl -o $@ -L https://github.com/gtk-rs/gir-files/raw/$(GIR_FILES_VERSION)/${@F}

gir-files/OSTree-1.0.gir:
	ln -sfr ../OSTree-1.0.gir $@

=== debian/changelog ===
bootc (1.9.0+composefs+vendor-0~2) unstable; urgency=medium

  * install dracut files

 -- Noah Meyerhans <noahm@debian.org>  Fri, 19 Sep 2025 12:14:03 -0400

bootc (1.9.0+composefs+vendor-0~1) unstable; urgency=medium

  * Use vendored dependencies
  * Patch dead_code compile failures

 -- Noah Meyerhans <noahm@debian.org>  Thu, 18 Sep 2025 12:20:56 -0400

bootc (1.9.0+composefs-0~2) unstable; urgency=medium

  * install bootc-initramfs-setup

 -- Noah Meyerhans <noahm@debian.org>  Wed, 17 Sep 2025 16:51:05 -0400

bootc (1.9.0+composefs-0~1) unstable; urgency=medium

  * New upstream version based on 19e82be84 ("Merge pull request #1444
    from bootc-dev/composefs-backend")

 -- Noah Meyerhans <noahm@debian.org>  Wed, 17 Sep 2025 15:50:00 -0400

bootc (1.7.1-1) UNRELEASED; urgency=medium

  * Initial release. (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Noah Meyerhans <noahm@debian.org>  Mon, 08 Sep 2025 15:57:46 -0400

=== debian/control ===
Source: bootc
Section: admin
Priority: optional
Maintainer: Noah Meyerhans <noahm@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libostree-dev,
 go-md2man,
 rustup <upstream-cargo>,
 cargo <!upstream-cargo>,
 libstd-rust-dev <!upstream-cargo>,
 rustc <!upstream-cargo>,
 librust-anstream-0.6+default-dev <!upstream-cargo>,
 librust-anstyle-1+default-dev (>= 1.0.6-~~) <!upstream-cargo>,
 librust-anyhow-1+default-dev (>= 1.0.82-~~) <!upstream-cargo>,
 librust-bootc-lib-1+default-dev (>= 1.7-~~) <!upstream-cargo>,
 librust-bootc-mount+default-dev <!upstream-cargo>,
 librust-bootc-sysusers+default-dev <!upstream-cargo>,
 librust-bootc-tmpfiles+default-dev <!upstream-cargo>,
 librust-camino-1+default-dev (>= 1.1.6-~~) <!upstream-cargo>,
 librust-camino-1+serde1-dev (>= 1.1.6-~~) <!upstream-cargo>,
 librust-canon-json-0.2+default-dev (>= 0.2.1-~~) <!upstream-cargo>,
 librust-cap-std-ext-4+default-dev (>= 4.0.3-~~) <!upstream-cargo>,
 librust-cap-std-ext-4+fs-utf8-dev (>= 4.0.3-~~) <!upstream-cargo>,
 librust-chrono-0.4-dev (>= 0.4.38-~~) <!upstream-cargo>,
 librust-chrono-0.4+serde-dev (>= 0.4.38-~~) <!upstream-cargo>,
 librust-chrono-0.4+std-dev (>= 0.4.38-~~) <!upstream-cargo>,
 librust-clap-4+cargo-dev (>= 4.5.4-~~) <!upstream-cargo>,
 librust-clap-4+default-dev (>= 4.5.4-~~) <!upstream-cargo>,
 librust-clap-4+derive-dev (>= 4.5.4-~~) <!upstream-cargo>,
 librust-comfy-table-7+default-dev (>= 7.1.1-~~) <!upstream-cargo>,
 librust-composefs-boot+default-dev <!upstream-cargo>,
 librust-composefs+default-dev <!upstream-cargo>,
 librust-composefs-oci+default-dev <!upstream-cargo>,
 librust-composefs+rhel9-dev <!upstream-cargo>,
 librust-containers-image-proxy-0.8+default-dev <!upstream-cargo>,
 librust-crossterm-0.29+default-dev <!upstream-cargo>,
 librust-dialoguer-0.11+default-dev <!upstream-cargo>,
 librust-flate2-1+zlib-dev (>= 1.0.20-~~) <!upstream-cargo>,
 librust-fn-error-context-0.2+default-dev (>= 0.2.1-~~) <!upstream-cargo>,
 librust-futures-util-0.3+default-dev (>= 0.3.13-~~) <!upstream-cargo>,
 librust-gvariant-0.5+default-dev <!upstream-cargo>,
 librust-hex-0.4+default-dev (>= 0.4.3-~~) <!upstream-cargo>,
 librust-indexmap-2+default-dev (>= 2.2.2-~~) <!upstream-cargo>,
 librust-indexmap-2+serde-dev (>= 2.2.2-~~) <!upstream-cargo>,
 librust-indicatif-0.18+default-dev <!upstream-cargo>,
 librust-indoc-2+default-dev (>= 2.0.5-~~) <!upstream-cargo>,
 librust-io-lifetimes-3+default-dev <!upstream-cargo>,
 librust-libc-0.2+default-dev (>= 0.2.154-~~) <!upstream-cargo>,
 librust-liboverdrop-0.1+default-dev <!upstream-cargo>,
 librust-libsystemd-0.7+default-dev <!upstream-cargo>,
 librust-libtest-mimic-0.8+default-dev <!upstream-cargo>,
 librust-linkme-0.3+default-dev <!upstream-cargo>,
 librust-log-0.4+default-dev (>= 0.4.21-~~) <!upstream-cargo>,
 librust-mandown-1+default-dev (>= 1.1.0-~~) <!upstream-cargo>,
 librust-nom-8+default-dev <!upstream-cargo>,
 librust-ocidir-0.4+default-dev <!upstream-cargo>,
 librust-oci-spec-0.8+default-dev <!upstream-cargo>,
 librust-openssh-keys-0.6+default-dev (>= 0.6.4-~~) <!upstream-cargo>,
 librust-openssl-0.10+default-dev (>= 0.10.72-~~) <!upstream-cargo>,
 librust-ostree-0.20+default-dev (>= 0.20.3-~~) <!upstream-cargo>,
 librust-ostree-0.20+v2025-3-dev (>= 0.20.3-~~) <!upstream-cargo>,
 librust-ostree-ext+bootc-dev <!upstream-cargo>,
 librust-ostree-ext+default-dev <!upstream-cargo>,
 librust-owo-colors-4+default-dev <!upstream-cargo>,
 librust-pin-project-1+default-dev <!upstream-cargo>,
 librust-regex-1+default-dev (>= 1.10.4-~~) <!upstream-cargo>,
 librust-rexpect-0.6+default-dev <!upstream-cargo>,
 librust-rustix-1+default-dev <!upstream-cargo>,
 librust-rustix-1+fs-dev <!upstream-cargo>,
 librust-rustix-1+mount-dev <!upstream-cargo>,
 librust-rustix-1+net-dev <!upstream-cargo>,
 librust-rustix-1+process-dev <!upstream-cargo>,
 librust-rustix-1+system-dev <!upstream-cargo>,
 librust-rustix-1+thread-dev <!upstream-cargo>,
 librust-rustix-1+use-libc-dev <!upstream-cargo>,
 librust-schemars-1+chrono04-dev (>= 1.0.4-~~) <!upstream-cargo>,
 librust-schemars-1+default-dev (>= 1.0.4-~~) <!upstream-cargo>,
 librust-serde-1+default-dev (>= 1.0.199-~~) <!upstream-cargo>,
 librust-serde-1+derive-dev (>= 1.0.199-~~) <!upstream-cargo>,
 librust-serde-ignored-0.1+default-dev (>= 0.1.10-~~) <!upstream-cargo>,
 librust-serde-json-1+default-dev (>= 1.0.116-~~) <!upstream-cargo>,
 librust-serde-yaml-0.9+default-dev (>= 0.9.22-~~) <!upstream-cargo>,
 librust-serde-yaml-0.9+default-dev (>= 0.9.34-~~) <!upstream-cargo>,
 librust-shlex-1+default-dev (>= 1.3-~~) <!upstream-cargo>,
 librust-tar-0.4+default-dev <!upstream-cargo>,
 librust-tar-0.4+default-dev (>= 0.4.43-~~) <!upstream-cargo>,
 librust-tempfile-3+default-dev (>= 3.10.1-~~) <!upstream-cargo>,
 librust-thiserror-2+default-dev (>= 2.0.11-~~) <!upstream-cargo>,
 librust-tini-1+default-dev (>= 1.3.0-~~) <!upstream-cargo>,
 librust-tokio+default-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio+io-std-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio+macros-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio+net-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio+process-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio+rt-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio+signal-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio-stream-0.1+default-dev (>= 0.1.8-~~) <!upstream-cargo>,
 librust-tokio-stream-0.1+sync-dev (>= 0.1.8-~~) <!upstream-cargo>,
 librust-tokio+time-dev (>= 1.37.0-~~) <!upstream-cargo>,
 librust-tokio-util-0.7+default-dev (>= 0.7.10-~~) <!upstream-cargo>,
 librust-tokio-util-0.7+io-util-dev (>= 0.7.10-~~) <!upstream-cargo>,
 librust-toml-0.9+default-dev (>= 0.9.5-~~) <!upstream-cargo>,
 librust-tracing-0.1+default-dev (>= 0.1.40-~~) <!upstream-cargo>,
 librust-tracing-subscriber-0.3+default-dev (>= 0.3.18-~~) <!upstream-cargo>,
 librust-tracing-subscriber-0.3+env-filter-dev (>= 0.3.18-~~) <!upstream-cargo>,
 librust-uapi-version-0.4+default-dev <!upstream-cargo>,
 librust-uuid-1+default-dev (>= 1.8.0-~~) <!upstream-cargo>,
 librust-uuid-1+v4-dev (>= 1.8.0-~~) <!upstream-cargo>,
 librust-uzers-0.12+default-dev <!upstream-cargo>,
 librust-which-8+default-dev <!upstream-cargo>,
 librust-xshell-0.2+default-dev (>= 0.2.6-~~) <!upstream-cargo>,
 librust-zstd-0.13+default-dev (>= 0.13.1-~~) <!upstream-cargo>,
 librust-zstd-0.13+pkg-config-dev (>= 0.13.1-~~) <!upstream-cargo>,
Standards-Version: 4.7.2
Homepage: https://github.com/bootc-dev/bootc
#Vcs-Browser: https://salsa.debian.org/debian/bootc
#Vcs-Git: https://salsa.debian.org/debian/bootc.git

Package: bootc
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 coreos-bootupd
Description: Transactional, in-place operating system updates using OCI container images
 The original Docker container model of using "layers" to model
 applications has been extremely successful. This project aims to
 apply the same technique for bootable host systems - using standard
 OCI/Docker containers as a transport and delivery format for base
 operating system updates.
 .
 The container image includes a Linux kernel (in
 e.g. /usr/lib/modules), which is used to boot. At runtime on a target
 system, the base userspace is not itself running in a "container" by
 default. For example, assuming systemd is in use, systemd acts as
 pid1 as usual - there's no "outer" process. More about this in the
 docs; see below.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PKG_CONFIG_PATH=/usr/lib/x86_64-linux-gnu/pkgconfig

%:
	dh $@

override_dh_auto_build:
	CARGO_FEATURES=composefs-backend make all

override_dh_auto_install:
	DESTDIR=debian/bootc make install-all install-initramfs-dracut

override_dh_clean:
	dh_clean -XCargo.toml.orig

execute_after_dh_auto_clean:
	-rm -rf target

override_dh_auto_test:
	cargo test

# dh_make generated override targets.
# This is an example for Cmake (see <https://bugs.debian.org/641051>).
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/bootc-dev/bootc/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
